#include <stdio.h>

extern struct rtpkt {
  int sourceid;       /* id of sending router sending this pkt */
  int destid;         /* id of router to which pkt being sent 
                         (must be an immediate neighbor) */
  int mincost[4];    /* min cost to node 0 ... 3 */
  };

extern int TRACE;
extern int YES;
extern int NO;

struct distance_table 
{
  int costs[4][4];
} dt0;


/* students to write the following two routines, and maybe some others */

static int oldcost = 1;
static int update_flag = 0;
static int stored_mincost[4] = {999, 999, 999, 999};

void rtinit0() 
{
  struct rtpkt packet;
  struct distance_table *dtptr;

  dt0.costs[1][1] = 1;
  dt0.costs[2][2] = 3;
  dt0.costs[3][3] = 7;
  dt0.costs[1][2] = 999;
  dt0.costs[1][3] = 999;
  dt0.costs[2][1] = 999;
  dt0.costs[2][3] = 999;
  dt0.costs[3][1] = 999;
  dt0.costs[3][2] = 999;
  packet.sourceid = 0;
  packet.destid = 1;
  packet.mincost[0] = 0;
  packet.mincost[1] = 1;
  packet.mincost[2] = 3;
  packet.mincost[3] = 7;
  tolayer2(packet);
  packet.destid = 2;
  tolayer2(packet);
  packet.destid = 3;
  tolayer2(packet);
  dtptr = &dt0;
  printdt0(dtptr);
}


void rtupdate0(rcvdpkt)
  struct rtpkt *rcvdpkt;
{
  struct rtpkt packet;
  struct distance_table *dtptr;
  int i, j;
  int min;

  if (rcvdpkt->sourceid == 1)
  {
    if (rcvdpkt->mincost[2] != 0)
    {   
      dt0.costs[1][2] = dt0.costs[2][2] + rcvdpkt->mincost[2];
      dt0.costs[2][1] = dt0.costs[1][1] + rcvdpkt->mincost[2];
    }
    if (rcvdpkt->mincost[3] != 0)
    {
      dt0.costs[1][3] = dt0.costs[3][3] + rcvdpkt->mincost[3];
      dt0.costs[3][1] = dt0.costs[1][1] + rcvdpkt->mincost[3];
    }
  }

  if (rcvdpkt->sourceid == 2)
  {
    if (rcvdpkt->mincost[1] != 0)
    {   
      dt0.costs[1][2] = dt0.costs[2][2] + rcvdpkt->mincost[1];
      dt0.costs[2][1] = dt0.costs[1][1] + rcvdpkt->mincost[1];
    }
    if (rcvdpkt->mincost[3] != 0)
    {
      dt0.costs[2][3] = dt0.costs[3][3] + rcvdpkt->mincost[3];
      dt0.costs[3][2] = dt0.costs[2][2] + rcvdpkt->mincost[3];
    }
  }
  
  if (rcvdpkt->sourceid == 3)
  {
    if (rcvdpkt->mincost[1] != 0)
    {   
      dt0.costs[1][3] = dt0.costs[3][3] + rcvdpkt->mincost[1];
      dt0.costs[3][1] = dt0.costs[1][1] + rcvdpkt->mincost[1];
    }
    if (rcvdpkt->mincost[2] != 0)
    {
      dt0.costs[2][3] = dt0.costs[3][3] + rcvdpkt->mincost[2];
      dt0.costs[3][2] = dt0.costs[2][2] + rcvdpkt->mincost[2];
    }
  }

  for (i = 1; i <= 3; i++)
  {
    min = 999;
    for (j = 1; j <= 3; j++) 
    {
      if (dt0.costs[i][j] < min)
      {
        min = dt0.costs[i][j];
      }
    }
    if (min != stored_mincost[i])
    {
      packet.mincost[i] = min;
      stored_mincost[i] = min;
      update_flag = 1;
    }
    else
    {
      packet.mincost[i] = 0;
    }
  }
  if (update_flag == 1)
  {
    packet.mincost[0] = 0;
    packet.sourceid = 0;
    packet.destid = 1;
    tolayer2(packet);
    packet.destid = 2;
    tolayer2(packet);
    packet.destid = 3;
    tolayer2(packet);
    update_flag = 0;
  }
  dtptr = &dt0;
  printdt0(dtptr);
}


printdt0(dtptr)
  struct distance_table *dtptr;
  
{
  printf("                via     \n");
  printf("   D0 |    1     2    3 \n");
  printf("  ----|-----------------\n");
  printf("     1|  %3d   %3d   %3d\n",dtptr->costs[1][1],
         dtptr->costs[1][2],dtptr->costs[1][3]);
  printf("dest 2|  %3d   %3d   %3d\n",dtptr->costs[2][1],
         dtptr->costs[2][2],dtptr->costs[2][3]);
  printf("     3|  %3d   %3d   %3d\n",dtptr->costs[3][1],
         dtptr->costs[3][2],dtptr->costs[3][3]);
}

linkhandler0(linkid, newcost)   
  int linkid, newcost;

/* called when cost from 0 to linkid changes from current value to
newcost*/
/* You can leave this routine empty if you're an undergrad. If you want */
/* to use this routine, you'll need to change the value of the LINKCHANGE
*/
/* constant definition in prog3.c from 0 to 1 */
        
{
  struct rtpkt packet;
  int cost_change; 
  int i, j;
  int min;

  cost_change = newcost - oldcost;
  oldcost = newcost;
  dt0.costs[1][1] = dt0.costs[1][1] + cost_change;
  dt0.costs[2][1] = dt0.costs[2][1] + cost_change;
  dt0.costs[3][1] = dt0.costs[3][1] + cost_change;

  for (i = 1; i <= 3; i++)
  {
    min = 999;
    for (j = 1; j <= 3; j++) 
    {
      if (dt0.costs[i][j] < min)
      {
        min = dt0.costs[i][j];
      }
    }
    if (min != stored_mincost[i])
    {
      packet.mincost[i] = min;
      stored_mincost[i] = min;
      update_flag = 1;
    }
    else
    {
      packet.mincost[i] = 0;
    }
  }
  if (update_flag == 1)
  {
    packet.mincost[0] = 0;
    packet.sourceid = 0;
    packet.destid = 1;
    tolayer2(packet);
    packet.destid = 2;
    tolayer2(packet);
    packet.destid = 3;
    tolayer2(packet);
    update_flag = 0;
  }
            
}


